// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/search/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeResourceRegistries implements ResourceRegistryInterface
type FakeResourceRegistries struct {
	Fake *FakeSearchV1alpha1
}

var resourceregistriesResource = schema.GroupVersionResource{Group: "search.karmada.io", Version: "v1alpha1", Resource: "resourceregistries"}

var resourceregistriesKind = schema.GroupVersionKind{Group: "search.karmada.io", Version: "v1alpha1", Kind: "ResourceRegistry"}

// Get takes name of the resourceRegistry, and returns the corresponding resourceRegistry object, and an error if there is any.
func (c *FakeResourceRegistries) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ResourceRegistry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(resourceregistriesResource, name), &v1alpha1.ResourceRegistry{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ResourceRegistry), err
}

// List takes label and field selectors, and returns the list of ResourceRegistries that match those selectors.
func (c *FakeResourceRegistries) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ResourceRegistryList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(resourceregistriesResource, resourceregistriesKind, opts), &v1alpha1.ResourceRegistryList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ResourceRegistryList{ListMeta: obj.(*v1alpha1.ResourceRegistryList).ListMeta}
	for _, item := range obj.(*v1alpha1.ResourceRegistryList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested resourceRegistries.
func (c *FakeResourceRegistries) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(resourceregistriesResource, opts))
}

// Create takes the representation of a resourceRegistry and creates it.  Returns the server's representation of the resourceRegistry, and an error, if there is any.
func (c *FakeResourceRegistries) Create(ctx context.Context, resourceRegistry *v1alpha1.ResourceRegistry, opts v1.CreateOptions) (result *v1alpha1.ResourceRegistry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(resourceregistriesResource, resourceRegistry), &v1alpha1.ResourceRegistry{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ResourceRegistry), err
}

// Update takes the representation of a resourceRegistry and updates it. Returns the server's representation of the resourceRegistry, and an error, if there is any.
func (c *FakeResourceRegistries) Update(ctx context.Context, resourceRegistry *v1alpha1.ResourceRegistry, opts v1.UpdateOptions) (result *v1alpha1.ResourceRegistry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(resourceregistriesResource, resourceRegistry), &v1alpha1.ResourceRegistry{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ResourceRegistry), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeResourceRegistries) UpdateStatus(ctx context.Context, resourceRegistry *v1alpha1.ResourceRegistry, opts v1.UpdateOptions) (*v1alpha1.ResourceRegistry, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(resourceregistriesResource, "status", resourceRegistry), &v1alpha1.ResourceRegistry{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ResourceRegistry), err
}

// Delete takes name of the resourceRegistry and deletes it. Returns an error if one occurs.
func (c *FakeResourceRegistries) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(resourceregistriesResource, name, opts), &v1alpha1.ResourceRegistry{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeResourceRegistries) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(resourceregistriesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.ResourceRegistryList{})
	return err
}

// Patch applies the patch and returns the patched resourceRegistry.
func (c *FakeResourceRegistries) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ResourceRegistry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(resourceregistriesResource, name, pt, data, subresources...), &v1alpha1.ResourceRegistry{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ResourceRegistry), err
}
