// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"context"
	"time"

	v1alpha2 "github.com/karmada-io/karmada/pkg/apis/work/v1alpha2"
	scheme "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterResourceBindingsGetter has a method to return a ClusterResourceBindingInterface.
// A group's client should implement this interface.
type ClusterResourceBindingsGetter interface {
	ClusterResourceBindings() ClusterResourceBindingInterface
}

// ClusterResourceBindingInterface has methods to work with ClusterResourceBinding resources.
type ClusterResourceBindingInterface interface {
	Create(ctx context.Context, clusterResourceBinding *v1alpha2.ClusterResourceBinding, opts v1.CreateOptions) (*v1alpha2.ClusterResourceBinding, error)
	Update(ctx context.Context, clusterResourceBinding *v1alpha2.ClusterResourceBinding, opts v1.UpdateOptions) (*v1alpha2.ClusterResourceBinding, error)
	UpdateStatus(ctx context.Context, clusterResourceBinding *v1alpha2.ClusterResourceBinding, opts v1.UpdateOptions) (*v1alpha2.ClusterResourceBinding, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha2.ClusterResourceBinding, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha2.ClusterResourceBindingList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.ClusterResourceBinding, err error)
	ClusterResourceBindingExpansion
}

// clusterResourceBindings implements ClusterResourceBindingInterface
type clusterResourceBindings struct {
	client rest.Interface
}

// newClusterResourceBindings returns a ClusterResourceBindings
func newClusterResourceBindings(c *WorkV1alpha2Client) *clusterResourceBindings {
	return &clusterResourceBindings{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterResourceBinding, and returns the corresponding clusterResourceBinding object, and an error if there is any.
func (c *clusterResourceBindings) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha2.ClusterResourceBinding, err error) {
	result = &v1alpha2.ClusterResourceBinding{}
	err = c.client.Get().
		Resource("clusterresourcebindings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterResourceBindings that match those selectors.
func (c *clusterResourceBindings) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha2.ClusterResourceBindingList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha2.ClusterResourceBindingList{}
	err = c.client.Get().
		Resource("clusterresourcebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterResourceBindings.
func (c *clusterResourceBindings) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("clusterresourcebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a clusterResourceBinding and creates it.  Returns the server's representation of the clusterResourceBinding, and an error, if there is any.
func (c *clusterResourceBindings) Create(ctx context.Context, clusterResourceBinding *v1alpha2.ClusterResourceBinding, opts v1.CreateOptions) (result *v1alpha2.ClusterResourceBinding, err error) {
	result = &v1alpha2.ClusterResourceBinding{}
	err = c.client.Post().
		Resource("clusterresourcebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterResourceBinding).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a clusterResourceBinding and updates it. Returns the server's representation of the clusterResourceBinding, and an error, if there is any.
func (c *clusterResourceBindings) Update(ctx context.Context, clusterResourceBinding *v1alpha2.ClusterResourceBinding, opts v1.UpdateOptions) (result *v1alpha2.ClusterResourceBinding, err error) {
	result = &v1alpha2.ClusterResourceBinding{}
	err = c.client.Put().
		Resource("clusterresourcebindings").
		Name(clusterResourceBinding.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterResourceBinding).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *clusterResourceBindings) UpdateStatus(ctx context.Context, clusterResourceBinding *v1alpha2.ClusterResourceBinding, opts v1.UpdateOptions) (result *v1alpha2.ClusterResourceBinding, err error) {
	result = &v1alpha2.ClusterResourceBinding{}
	err = c.client.Put().
		Resource("clusterresourcebindings").
		Name(clusterResourceBinding.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterResourceBinding).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the clusterResourceBinding and deletes it. Returns an error if one occurs.
func (c *clusterResourceBindings) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clusterresourcebindings").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterResourceBindings) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("clusterresourcebindings").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched clusterResourceBinding.
func (c *clusterResourceBindings) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.ClusterResourceBinding, err error) {
	result = &v1alpha2.ClusterResourceBinding{}
	err = c.client.Patch(pt).
		Resource("clusterresourcebindings").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
